Subject: Re: [PATCH v4] powerpc: Use shared font data

From: "Dr. David Alan Gilbert" <[email-masked]>
Date: Mon, 3 Nov 2025 01:48:39 +0000

* Finn Thain ([email-masked]) wrote:
> 
> On Sun, 2 Nov 2025, Dr. David Alan Gilbert wrote:
> 
> > 
> > So I'm not a PPC person specifically; so lets see if the PPC people have 
> > any suggestions, but:
> > 
> >    a) Do you know if there's any way to recreate the same hang/works 
> > combination in qemu; I know it has a g3beige model but I don't know how 
> > to get something similar to your failing combo.
> > 
> 
> I guess we could probably reproduce this in QEMU if the BootX bootloader 
> could be made to work there. In theory, 'qemu-system-ppc -M g3beige' might 
> work.
> 
> >    b) Can you get any diagnostics out of the prom on the mac?  Like a PC 
> > or anything to have some idea where it hung?
> > 
> 
> Well, that's the problem: if you enable the CONFIG_BOOTX_TEXT diagnostics, 
> the system hangs instead of printing stuff. If you disable the 
> CONFIG_BOOTX_TEXT diagnostics (in favour of serial diagnostics) the hang 
> goes away.

Ah, a bug that doesn't like to be seen :-)

> Anyway, I imagine that the problem with your patch was that it relies on 
> font data from a different (read only) section, which is unavailable for 
> some reason (MMU not fully configured yet?)
> 
> So I've asked Stan to test a patch that simply removes the relevant 
> 'const' keywords. It's not a solution, but might narrow-down the search.

I wonder if this is a compiler-flag-ism; I see arch/powerpc/kernel/Makefile
has a pile of special flags, and for btext.o it has a -fPIC
(as well as turning off some other flags).
I wonder if bodging those in lib/fonts/Makefile for lib/fonts/font_sun8x16.c
fixes it?
But... this is data - there's no code is there - are any of those flags
relevant for data only?

> >    c) Is this only the Powerbooks that are unhappy - are other Macs OK 
> > with this - if so, wth is the difference with a powerbook?  Is it a 
> > different debian config or something?
> > 
> 
> The BootX bootloader doesn't work on New World systems, which is probably 
> why we don't see this regression on anything newer than a Wallstreet. 
> 
> It's likely that other Old World systems are also affected, if they are 
> using BootX. We don't yet know whether the regression also affects Old 
> World systems using the iQUIK bootloader instead of BootX.

OK, remember I don't think I've ever tried PPC via MacOS booting, so not
familiar with it.

Dave
-- 
 -----Open up your eyes, open up your mind, open up your code -------   
/ Dr. David Alan Gilbert    |       Running GNU/Linux       | Happy  \ 
\        dave @ treblig.org |                               | In Hex /
 \ _________________________|_____ http://www.treblig.org   |_______/